# FIXME some missing dependencies for tests of python3_other 
%bcond_with python3_other_tests

%global pypi_name urllib3

Name:           python3-%{pypi_name}
Version:        1.25.6
Release:        1%{?dist}
Summary:        Python 3 HTTP library with thread-safe connection pooling and file post

License:        MIT
URL:            https://urllib3.readthedocs.io/
Source0:        %pypi_source
Patch0:         python3-%{pypi_name}-unbundle.patch

BuildArch:      noarch

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-setuptools
# For unittests
BuildRequires:  python%{python3_pkgversion}-coverage
BuildRequires:  python%{python3_pkgversion}-mock
BuildRequires:  python%{python3_pkgversion}-nose
BuildRequires:  python%{python3_pkgversion}-pysocks
BuildRequires:  python%{python3_pkgversion}-pytest
BuildRequires:  python%{python3_pkgversion}-six >= 1.12.0
BuildRequires:  python%{python3_pkgversion}-tornado
%if 0%{?python3_other_pkgversion}
BuildRequires:  python%{python3_other_pkgversion}-devel
BuildRequires:  python%{python3_other_pkgversion}-setuptools
# For unittests
%if %{with python3_other_tests}
BuildRequires:  python%{python3_other_pkgversion}-coverage
BuildRequires:  python%{python3_other_pkgversion}-mock
BuildRequires:  python%{python3_other_pkgversion}-nose
BuildRequires:  python%{python3_other_pkgversion}-pysocks
BuildRequires:  python%{python3_other_pkgversion}-pytest
BuildRequires:  python%{python3_other_pkgversion}-six >= 1.12.0
BuildRequires:  python%{python3_other_pkgversion}-tornado
%endif
%endif

%global _description Python 3 HTTP module with connection pooling and file POST abilities.
%description
%_description

%package -n python%{python3_pkgversion}-%{pypi_name}
Summary:        Python %{python3_version} HTTP library with thread-safe connection pooling and file post
Requires:       ca-certificates
Requires:       python%{python3_pkgversion}-pysocks
Requires:       python%{python3_pkgversion}-six >= 1.12.0
Provides:       bundled(python%{python3_pkgversion}-ssl_match_hostname)
%{?python_provide:%python_provide python%{python3_pkgversion}-%{pypi_name}}

%description -n python%{python3_pkgversion}-%{pypi_name}
%_description
This package is for Python3 version %{python3_version} .

%if 0%{?python3_other_pkgversion}
%package -n python%{python3_other_pkgversion}-%{pypi_name}
Summary:        Python %{python3_version} HTTP library with thread-safe connection pooling and file post
Requires:       ca-certificates
Requires:       python%{python3_other_pkgversion}-pysocks
Requires:       python%{python3_other_pkgversion}-six >= 1.12.0
Provides:       bundled(python%{python3_other_pkgversion}-ssl_match_hostname)
%{?python_provide:%python_provide python%{python3_other_pkgversion}-%{pypi_name}}

%description -n python%{python3_other_pkgversion}-%{pypi_name}
%_description
This package is for Python3 version %{python3_other_version} .
%endif


%prep
%autosetup -p1 -n %{pypi_name}-%{version}
# Use system packages
rm -r src/%{pypi_name}/packages/six.py
find -name \*.py | xargs sed -i -e '/six/ s/from \(%{pypi_name}\|\.\)\?\.packages //' -e '/six/ s/from \(%{pypi_name}\|\.\)\?\.packages\./from /'

%build
%py3_build
%if 0%{?python3_other_pkgversion}
%py3_other_build
%endif

%install
%py3_install
%if 0%{?python3_other_pkgversion}
%py3_other_install
%endif

%check
pushd test
# Some tests use param or yield, not supported with pytest 2.9.2
rm -f test_util.py
PYTHONPATH=%{buildroot}%{python3_sitelib}:%{python3_sitelib} %{__python3} -m pytest -v -k "not test_wait and not test_io and not test_same_host_custom_protocol and not test_recent_date and not test_source_address_error"
%if 0%{?python3_other_pkgversion}
%{?with python3_other_tests:PYTHONPATH=%{buildroot}%{python3_other_sitelib}:%{python3_other_sitelib} %{__python3_other} -m pytest -v}
%endif
popd


%files -n python%{python3_pkgversion}-%{pypi_name}
%license LICENSE.txt
%doc CHANGES.rst README.rst
%{python3_sitelib}/%{pypi_name}/
%{python3_sitelib}/%{pypi_name}-*.egg-info

%if 0%{?python3_other_pkgversion}
%files -n python%{python3_other_pkgversion}-%{pypi_name}
%license LICENSE.txt
%doc CHANGES.rst README.rst
%{python3_other_sitelib}/%{pypi_name}/
%{python3_other_sitelib}/%{pypi_name}-*.egg-info
%endif


%changelog
* Sat Feb  8 2020 Orion Poplawski <orion@nwra.com> - 1.25.6-1
- Update to 1.25.6 (bz#1787227)

* Mon Nov  4 2019 Orion Poplawski <orion@nwra.com> - 1.25.1-1
- Update to 1.25.1, fixes CVE (bz#1702475)

* Thu Mar 07 2019 Troy Dawson <tdawson@redhat.com> - 1.19.1-5
- Rebuilt to change main python from 3.4 to 3.6

* Sat Sep 29 2018 Raphael Groner <projects.rg@smart.ms> - 1.19.1-4
- add python3_other subpackage
- add BR: python3X-setuptools
- use pypi macros

* Fri Jan 6 2017 Orion Poplawski <orion@cora.nwra.com> - 1.19.1-3
- Install symlink to system six.py

* Sun Nov 27 2016 Orion Poplawski <orion@cora.nwra.com> - 1.19.1-2
- Patch to use system six
- Do not attempt change ssl handling

* Tue Nov 22 2016 Orion Poplawski <orion@cora.nwra.com> - 1.19.1-1
- Update to 1.19.1

* Fri Sep 16 2016 Orion Poplawski <orion@cora.nwra.com> - 1.16-1
- Initial EPEL7 package
